////////////////// sDS18B20.h ///////////////////
//        Ewald sr, www.kendziorra.nl          //
//   a very simple DS18B20 mini "1-Wire" lib.  //
//  Nov 2020, completely free to edit and use  //
//---------------------------------------------//
//    use it as class for a single DS18B20     //
//              -----      -------             //
//        each sensor it's own IO-port         //
//         normal mode (NOT parasite)          //
// No other 1-wire or Dallas library is needed //
//---------------------------------------------//
//   tested and OK with an ESP32 DevkitC V4    //
////////////////// sDS18B20.h ///////////////////

#include "sDS18B20.h"

const uint8_t tempPin_1 = 19;  // DS18B20, + 4.7 KOhm, 1-wire (NOT parasite)
const float tempComp_1 = 0.5;  // compensate the ESP modules warm up, in +/-n.n*C
float temp;       

sDS18B20 DS;

void setup() {
  Serial.begin(115200);
  while (!Serial); delay(1000);
  Serial.println("\n");
  temp = DS.getTemp(tempPin_1, tempComp_1);
  Serial.printf("(ERROR if temp=999.9) %3.1f*C\n", DS.getTemp());
  
}

void loop() {
  Serial.printf("%3.1f*C\n", DS.getTemp());
  delay(3000);
}
