#include <sDateTimeSun.h>  // www.kendziorra.nl (simpleLib)

/** DEFAULT VALUES in "sDateTimeSun.h" **/
// ***** strftime: http://www.cplusplus.com/reference/ctime/strftime
// ***** we assume by default that Monday is the first day of the week (ISO 8601)
//const char strfweek = 'V';// strftime: 'V'=ISO 8601 week number (01-53)
//const char strfwday = 'u';// strftime: 'u'=ISO 8601 weekday as number with Monday as 1 (1-7)
                  // ***** do not change the char[][] dimensions
//const char monthsLstr[12][21] = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
//const char monthsSstr[12][11] = {"Jan", "Feb", "Mar", "Apr", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"};
//const char daysLstr[7][21] = {"Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday"};// strftime _wday: 'u'
//const char daysSstr[7][11] = {"Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"};// strftime _wday: 'u'
//** END DEFAULT VALUES **/

// ***** List of timezones https://sites.google.com/a/usapiens.com/opnode/time-zones
//char timeZone[] = "CET-1CEST-2,M3.5.0/02:00:00,M10.5.0/03:00:00";  // EU Amsterdam/Barcelona with Summertime (DST)
//                    /** "EST5EDT,M3.2.0,M11.1.0";// USA Eastern Time with DST **/
//                    /** "CET-1";// EU Amsterdam/Barcelona NO DST/Summertime) **/
sEpoch ep;
sDateTime dt;

void prnt() {
  Serial.printf("     %02d-%02d-%02d %02d:%02d:%02d.%03d wday:%2d, week:%3d, yday:%4d,"
                " tz:%6d, dst:%5d, offset:%6d\n           %s, %s, %s, %s, int64_t: %lld, string: \"%s\"\n",
                 dt.day, dt.month, dt.year, dt.hour, dt.minute, dt.second, 
                 dt.msec, dt.wday, dt.week, dt.yday, dt.zone, dt.dst, dt.offset,
                 dt.monthL, dt.monthS, dt.dayL, dt.dayS, sTimestampInt(ep), sTimestampStr(ep).c_str());
    // milliseconds timestamp int64_t: 
    //    "%lld", sTimestampInt(ep)
    //  or as
    //    "%d%03d", dt.sec, dt.msec 
}

void setup() {
  Serial.begin(115200);
  Serial.println("\n");
  /** optional: use the default values or set your one 
   *  DEFAULT VALUES
   *  strfweek: 'V',  // week number     - strftime DEFAULT VALUE: 'V'=ISO 8601 week number (01-53)   
   *  strfwday: 'u';// day of the week - strftime DEFAULT VALUE: 'u'=ISO 8601 weekday as number with Monday as 1 (1-7)
   *  monthsLstr, monthsSstr, daysLstr, daysSstr: local Long/Short month an day names
   **/
//  sSetWeek(strfweek);
//  sSetWday(strfwday);
//  sSetMonthDayStr(monthsLstr, monthsSstr, daysLstr, daysSstr);
  /** optional END **/  
    
  // in this example we set the system timer manual
  timeval n = {.tv_sec = 1590085927};
  settimeofday(&n, NULL);
  // in other examples: How to synchronize the time with an NTP server every day
}

void loop() {
  ep = sNow();
  dt = sTimeDate(false, ep);
  Serial.println("struct dt = sTimeDate(bool false, struct ep) values ...");
  Serial.println("... from sNow():");
  prnt();
  ep.sec -= sOneday;
  dt = sTimeDate(false, ep);
  Serial.println("... from sNow() - sOneday:");
  prnt();
  ep.sec = 1577880000;
  ep.msec = 0;
  dt = sTimeDate(false, ep);
  Serial.println("... from timestamp 1577880000:");
  prnt();
  ep = sMakeTime(10, 30, 30, 333, 21, 9, 2020);
  dt = sTimeDate(false, ep);
  Serial.println("... from sMakeTime(10, 30, 30, 333, 21, 9, 2020):");
  prnt();
  Serial.println("\n");

  delay(999);
}
