/** ***************************
  * Ewald Kendziorra sr, 2019 *
  *   totally free to use     *
  *     www.kendziorra.nl     *
  *****************************/
// ESP-NOW that is direct PTOP communication without login. A perfect Mash alternative.
// Simple-ESP-NOW: an unlimited number of nodes with only 20 MAC addresses in use (or reserved).
// MAC addresses are used by Shared (0-99 on 'one' MAC address) and Paired (0-99 on a private address) nodes.
// Think it is a postal address: MAC(building) 00-19, Shared(flour) 00-99, Paired(room) 00-99, 20x100x100=200,000 nodes ;=)) 
// A node can also be used as two way relay to bridge larger distances (each node is in Access point and Station mode).
// Example adressing: "001122"; "00": MAC (00-19), "11": Shared address on MAC, "22": Private address on Shared.

const char now_Address[7] = "000000",
           now_SSID[11] = "mySThing",  // max. 10 chars
           now_Pswrd[] = "mySTpswrd";
const uint8_t now_Channel = 3;
#include <sESPNOWbasic.h>

void setup() {
  Serial.begin(115200);
  Serial.println("\n...\n");
  if (!now_initEspnow()) {
    Serial.println("ERROR: initEspnow() initialization failed!!!");
    while (1) {yield();}
  }
}

void loop() {
  static uint8_t  n = 0;
  static uint32_t t = millis() + 5000;
  if (millis() > t) {
    char msg[15] = "Node 00, ";
    strcat(msg, String(n++).c_str());
    now_sendData(0, msg);
    t = millis() + 5000;
  }
  yield();
}
