/** Ewald sr, aug 2020 www.kendziorra.nl 
 **  we use only ADC1-ports **
 *          ESP32 GPIO  
 * ADC1_CHANNEL_0: 36  
 * ADC1_CHANNEL_1: 37  
 * ADC1_CHANNEL_2: 38  
 * ADC1_CHANNEL_3: 39  
 * ADC1_CHANNEL_4: 32  
 * ADC1_CHANNEL_5: 33  
 * ADC1_CHANNEL_6: 34  
 * ADC1_CHANNEL_7: 35  
 * -  
 * ADC_WIDTH_BIT_9,  0-511  
 * ADC_WIDTH_BIT_10, 0-1023  
 * ADC_WIDTH_BIT_11, 0-2047  
 * ADC_WIDTH_BIT_12, 0-4095  
 * -  
 * ADC_ATTEN_DB_0,   0-1.1V  
 * ADC_ATTEN_DB_2_5, 0-1.5V  
 * ADC_ATTEN_DB_6,   0-2.2V  
 * ADC_ATTEN_DB_11,  0-3.9V  
 * -  
 * number of cycles per sample, default is 8, range is 1 - 255  
 * number of samples in the range, default is 1, range is 1 - 255
**/

#include <sEspAdc.h>

const uint8_t nPins = 4,  // as example we use 4 ports
              adcPin[nPins] = {32, 33, 34, 35};  // ADC1_CHANNEL_4 to ADC1_CHANNEL_7
/** user values **/
//const uint8_t cycles = 8,   // default 8
//              samples = 1;  // default 1
//const int16_t DEFAULT_VREF = 1100;  // default 1100
//adc_atten_t ADC_ATTEN_DB = ADC_ATTEN_DB_11;  // default 0-3.9V
//adc_bits_width_t ADC_WIDTH_BIT = ADC_WIDTH_BIT_12; // default 0-4095
/****/

void setup() {
  Serial.begin(115200);
  Serial.println("...\n");
  // sInitAdc(cycles, samples, DEFAULT_VREF, ADC_ATTEN_DB, ADC_WIDTH_BIT);  // set user values, return EFUSE-type
  // Serial.println(sInitAdc());  // use default values, return EFUSE-type
  //   or "auto default init" via function "sAdcRead"
}

void loop() {  
  static time_t t = millis();
  if (millis() >= t) {
    for (uint8_t i = 0; i < nPins; i++) {  // as example: read "nPins" ports
      uint32_t adc  = sAdcRead(adcPin[i]);  // default: take the average of "2" measurements
      uint32_t volt = sAdcVolt(adcPin[i]);  //    "     "   
                    //  "  "  (adcPin[i], n) take the average of "n" measurements
      Serial.printf("GPIO%u: %04u ADC, %04u mV  ", adcPin[i], adc, volt);
    }
    Serial.println();
    t = millis() + 5000;  // 5 sec. delay
  }
}
