var socketIP = networkSTA;  // Station mode
var stopWS = true;  // true: avoid automatic connection
var rbutton = 'rbnSTA';  // holt active radio button

/********** proceed data **********/
function commandMsg(msg) {  // is used by WebsocketClient.js
  if (!(msg.startsWith('|') && msg.endsWith('|'))) return;
  doShift();
  $('#respons0').html(msg);
}

/********** network radio buttons **********/
$('input[type=radio]').change(function(e) {
  if (!isConnected) {
    if (this.id == 'rbnSTA') {
      socketIP = networkSTA;
      rbutton = 'rbnSTA';
    } else {
      socketIP = networkWWW;
      rbutton = 'rbnWww';
    }
  }
  else $('#' + rbutton ).prop('checked', true);
});

/********** dis/connect buttons **********/
$('#btnConnect').click(function() {
  if (!isConnected) {   // connect to server
    stopWS = false;
    if (!isConnected) {
      init();
    }
  }
  else {  // disconnect fom server
    stopWS = true;
    if (isConnected) {
      websocket.close();
      websocket = null; 
    }
  }
});

/********** commands **********/
$('#btnSend').click(function() {  // connect to server
  if (!isConnected) {
    $('#toServer').text('NOT connected!!!');
    return;
  }
  publish($('#data').val());
});

$('#data').keyup(function(e) {  // connect to server
  if(e.keyCode == 13) {
    if (!isConnected) {
      $('#toServer').text('NOT connected!!!');
      return;
    }
    publish($('#data').val());
  }
});

$('#btnClear').click(function() {  // clear responsses
  clear();
});
  
/********** diverse **********/
function errorMsg(error) {  // show Websocket error
  doShift();
  $('#respons0').text(error);
}

function disCon() {  // show connected or disconnected
   if (isConnected) {   // connect to server
    $('#btnConnect').text('DisConnect');
    $('#ledPic').attr('src', 'include/green.jpg');
  }
  else {  // disconnect fom server
    $('#btnConnect').text('Connect');
    $('#ledPic').attr('src', 'include/red.jpg');
  }
}

function clear() {
  $('#respons0').text('');
  $('#respons1').text('');
  $('#respons2').text('');
  $('#respons3').text('');
  $('#respons4').text('');
}

function doShift() {  // shift responses down
  $('#respons4').text($('#respons3').text());
  $('#respons3').text($('#respons2').text());
  $('#respons2').text($('#respons1').text());
  if ($('#respons0').text() != '') $('#respons1').text($('#respons0').text());
}
