#include <sTimers.h>

/** create two timers **/
sTimers timer1(5000, true);   // interval 5 sec. and start this timer
sTimers timer2(2000, false);  // interval 2 sec. and do not start this timer

uint8_t i = 0;  // interval counter timer1

void setup() {
  Serial.begin(115200);
  Serial.println('\n...\n');
  timer2.tmrStart(true);  // start timer2

  // example: get offset and how to change timer(s) offset
  uint32_t ms1 = timer1.tmrMs(); // get timer1 interval in millis
  uint32_t ms2 = timer2.tmrMs(); // get timer2 interval in millis
  timer1.tmrReset(ms2, true);  // stop, set new time in millis and false: wait, true: start
  timer2.tmrReset(ms1, true);  // stop, set new time in millis and false: wait, true: start
}

void loop() {
  // display: 1 1 2 2 2 2 2 1 1 2 2 2 2 2 1 1 2 2 2 2 2 1 1 2 2 .......
  if (timer1.tmrTime()) Serial.println(1);  // timer1 time?
  if (timer2.tmrTime()) {                   // timer2 time?
    Serial.println(2);
    if (i++ == 0) timer1.tmrStart(false);   // stop timer1
    else if (i == 5) {
      timer1.tmrStart(true);                // start timer1
      i = 0;
    }
  }
}