/**  sWebbrowser Monitor EXAMPLE with my sWiFi library
  *  Totally free to use and modify
  *  Ewald Kendziorra sr, 2020, www.kendziorra.nl       **/
//        **** Use a Webbrowser as a Monitor ****        //
//           ESP32 Browser Monitor EXAMPLE               //
//           -----------------------------               //
//       Use "WebMonitor.htlm" as Arduino monitor        //
//        It's in the sWebMonitor example folder         //
// ----------------------------------------------------- //
/**  sWifiFull: a very easy to use ESP32 WiFi library.
  *  - Automatic initialization and connection
  *  - 'stays alive' control
  *  - eleven freely selectable options
  *  Totally free to use and modify
  *  Ewald Kendziorra sr, 2020, www.kendziorra.nl 
  ****************************************************/ 

#define USE_STA        // use WiFi mode STA
#ifdef USE_STA         // only station mode
  #define USE_STAIP    // if using a static STA IP (is needed with: USE_WS)
//  #define USE_STADNS   // use WiFi STA DNS
//  #define USE_STACHAN  // used in AP_STA mode
//  #define USE_OTA      // ArduinoOTA
//  #define USE_TIME     // NTP, date, time, timezone, DST/Summertime /** my simpleLIB library: sDateTimeSun.h       **/
  #define USE_WS       // WebSockets Server         /** library: https://github.com/Links2004/arduinoWebSockets **/
//  #define USE_WTHR     // Weather, Sunrise, Sunset                  /**                       sOpenweathermap.h **/
#endif
//#define USE_AP         // use WiFi mode AP
#ifdef USE_AP          // only softAp mode
  #define USE_APIP     // if using a static AP IP 
  #define USE_APCHAN   // used in AP_STA mode
  #define USE_APHID    // SSID hidden
  #define USE_APMAXCON // max connections, default 4, max 10
  #define USE_NOW      // ESP-NOW only in softAP mode
#endif
#if defined(USE_NOW) || defined(USE_WS)
//  #define USE_PARSER   // parse the received message to fieldnames an fieldValues 
#endif
#if defined(USE_STA) && defined(USE_AP) 
  #define USE_LR       // ESP32 softAP Long Range mode up to 1000m (only in AP_STA mode)
#endif

const char staSsid[] = "EDIT_EDIT"@,
       staPassword[] = "EDIT_EDIT"@;
const char wsURI[] = "/",                   // FIXED: WebSocket URI, also in HTML
      wsProtocol[] = "myWebMonitor";        // project name,  also in HTML
const IPAddress staIP(192, 168, 178, 125),  // IP also in HTML
         staGatewayIP(192, 168, 178,   1),
          staSubnetIP(255, 255, 255,   0);
const uint16_t wsPort = 8090;       // used TCP Port, also in HTML
const byte nFields = 8,   // the max. number of a set names/values
         nMaxChars = 60;  // the max. length of a message
char fldIn[nFields][nMaxChars + 1],  // parse received message to fieldnames an fieldValues 
     valIn[nFields][nMaxChars + 1];  //   ... |toadr|fromadr|field-1|val-1|field-2|val-2|...|...

#include <sWiFiFull.h>  // always under the optional #define xyz declarations

void wsAction();

void setup() {
  Serial.begin(115200);
  while (!Serial); delay(1000);
  Serial.println("\n");
  setupWiFi();  // is necessary on this place - init all your defined choices
}

void loop() {
  loopWiFi();  // is necessary on this place - connection 'stays alive' control
  if (wsVal) wsAction();  // WebSocket data received
  static uint8_t n = 0;
  static char c[21];
  static time_t t = millis();
  if (millis() > t) {
    t = millis();
    sprintf(c, "millis: %u", t);
    t += 5000;
    webSocket.broadcastTXT(c);
  }
}

void wsAction() {  // wsBuf is a String
  char msg[wsBuf.length() + 1];
  strcpy(msg, wsBuf.c_str());
  Serial.printf("msg: %s\n", msg);  // a command from user?!. in this demo to USB-monitor
  wsVal = false;
}
