#include <sI2Cwire.h>

uint8_t sI2Caddr = 0x68;  // address from device

void setup() {
  Serial.begin(115200);
  Serial.println("\n...\n");
  
  /** read 10 bytes **/
  uint8_t reg = 0x75,  // register to read
          len = 10,    // bytes to read
          r0buf[len] = {sI2Caddr, reg};  // read buffer with address and register to start reading
  int16_t res0 = sI2Cread(len, r0buf);   // get first byte or -1 if timeout
                                        // len:    the number of bytes to read
                                        // input:  device.address in buf[0] and reg.address in buf[l]
                                        // output: buf[0+], return: int16_t buf[0] or -1 if timeout
  if (res0 != -1) for (uint8_t i = 0; i < len; i++) Serial.printf("0x%X \n", r0buf[i]);  // display all bytes
  else Serial.println("read ERROR");

  /** read one byte **/
  reg = 0x75;  // register to read
  uint8_t r1buf[2] = {sI2Caddr, reg};  // read buffer with address and register to start reading
  int16_t res1 = sI2Cread(1, r1buf);   // get a byte or -1 if timeout
                                       // len:    one byte to read
                                       // input:  device.address in buf[0] and reg.address in buf[l]
                                       // output: buf[0], return: int16_t buf[0] or -1 if timeout
  if (res1 != -1) Serial.printf("res1:0x%X, buf[0]:0x%X \n", res1, r1buf[0]);  // display byte
  else Serial.println("read ERROR");

  /** write n bytes **/
  len = 5;     // 2 + n (address, register, data_1, data_2, ...)
  reg = 0x32;  // register to write
  uint8_t w0buf[len] = {sI2Caddr, reg, 0x01, 0x02, 0x03}; // write buffer with address and data to start writing
  sI2Cwrite(len, w0buf);  // write all bytes
                         // input: device.address in buf[0], register in buf[1] and data byte(s) to write buf[2+]
  /** write one byte **/
  len = 3;     // 2 + 1 (address, register, data)
  reg = 0x32;  // register to write
  uint8_t w1buf[len] = {sI2Caddr, reg, 0x00}; // write buffer with address and data to start writing
  sI2Cwrite(len, w1buf);  // write one byte
                          // input: device.address in buf[0], register in buf[1] and data byte(s) to write buf[2+]
                          
  // use <sBytesToUintToBytes.h> for: bytes/uint8_t to uint16_t and uint16_t to bytes/uint8_t
  // swap: true = LSB<->MSB  
  //sBytesToInt(swap, lenSource, uint8_t* source, int16_t* dest);
  //sIntToBytes(bool swap, uint8_t lenDest, int16_t* source, uint8_t* dest);

}

void loop() {

}
