#ifndef _S_BYTES_UINT16_BYTES_H_
#define _S_BYTES_UINT16_BYTES_H_

bool sBytesToInt(bool _swap, uint8_t _lenSource, uint8_t* _source, uint16_t* _dest);
bool sIntToBytes(bool _swap, uint8_t _lenDest, uint16_t* _source, uint8_t* _dest);

/** byte[] to int[] **/
bool sBytesToInt(bool _swap, uint8_t _lenSource, uint8_t* _source, uint16_t* _dest) {
  if ((_lenSource % 2) != 0) return false;
  uint8_t p = 0, msb, lsb;
  for (uint8_t i = 0; i < (_lenSource / 2); i++) {
    msb = _source[p++];
    lsb = _source[p++];
    if (_swap) std::swap(msb, lsb);
    _dest[i] = (int16_t)(((int16_t)msb << 8) | lsb);  // combinate msb and lsb
  }    
  return true;
}

/** int[] to byte[] **/
bool sIntToBytes(bool _swap, uint8_t _lenDest, uint16_t* _source, uint8_t* _dest) {
  if ((_lenDest % 2) != 0) return false;
  uint8_t p = 0, msb, lsb, l = _lenDest / 2;
  for (uint8_t i = 0; i < l; i++) {
    msb = _source[i] >> 8;  // strip lsb
    lsb = _source[i];       // strip msb
    if (_swap) std::swap(msb, lsb);
    _dest[p++] = msb;
    _dest[p++]= lsb;
  }    
  return true;
}

#endif
