/**   Download a LOG-FILE from    *
  * SD-Card, SPIFFS-MEM, FFat-MEM *
  *-------------------------------*
  * download my simpleLib library *
  * www.kendziorra.nl             *
  *-------------------------------**/
#ifndef _DOWNLOAD_LOG_FILE_H_
  #define _DOWNLOAD_LOG_FILE_H_
 
  #include <WebServer.h>

  WebServer server(wsPort);

  void downloadLog(){
    #ifdef USE_SD
      File download = SD.open(logPath + logFile);
    #elif defined(USE_SPIFFS)
      File download = SPIFFS.open(logPath + logFile);
    #elif defined(USE_FFAT)
      File download = FFat.open(logPath + logFile);
    #endif
    if (download) {
      server.sendHeader("Content-Type", "text/text");
      server.sendHeader("Content-Disposition", "attachment; filename=" + logFile);
      server.sendHeader("Connection", "close");
      server.streamFile(download, "application/octet-stream");
      download.close();
    }
  }
  
#endif  
