#ifndef _LUXBH1750_H_
#define _LUXBH1750_H_

#include <Wire.h>

int16_t BH1750 = 0x23;  // 0x23 - BH1750 I2C address
void sLuxInit(uint16_t address = BH1750);
uint32_t sGetLux();

void sLuxInit(uint16_t address) {
  Wire.begin();
  BH1750 = address;
  Wire.beginTransmission(BH1750);
  Wire.write(0x10);
  Wire.endTransmission();
  sGetLux();  // the first values are sometimes wrong ...
  sGetLux();  // ... so twice
}

uint32_t sGetLux() { 
  uint8_t buff[2];
  uint32_t val = 999999;
  Wire.beginTransmission(BH1750);
  Wire.requestFrom(BH1750, 2);
  if (Wire.available() == 2) {
    buff[0] = Wire.read();
    buff[1] = Wire.read();
    val = ((buff[0] << 8) | buff[1]) / 1.2;
  }
  Wire.endTransmission();  
  return val;   // if value 999999: lux is not read
}

#endif
