#ifndef _SPING_SR403_H_
#define _SPING_SR403_H_

const uint16_t pTimeOut = 31000;
uint8_t pTrigPin, pEchoPin, pDivisor;  // divisor: +/- 60 = cm, +/- 150 = inch 
void pingInit(int8_t tPin, int8_t ePin, double divi);
void doPing(int16_t *pResult);

void pingInit(int8_t tPin, int8_t ePin, double divi) {
  pTrigPin = tPin;
  pEchoPin = ePin;
  pDivisor = divi;
  pinMode(pTrigPin, OUTPUT);
  pinMode(pEchoPin, INPUT_PULLUP);
  digitalWrite(pTrigPin, LOW);  
}

void doPing(int16_t *pResult) {
  digitalWrite(pTrigPin, LOW);
  delayMicroseconds(1); 
  digitalWrite(pTrigPin, HIGH);
  delayMicroseconds(10); 
  digitalWrite(pTrigPin, LOW);
  pResult[0] = pulseIn(pEchoPin, HIGH, pTimeOut);
  if(pResult[0] > 0 && pResult[0] < pTimeOut) pResult[1] = pResult[0] / pDivisor;
  else {
    pResult[0] = -1;
    pResult[1] = -1;
  }   
}

#endif
