#ifndef _RECEIVE_433_H_
#define _RECEIVE_433_H_

typedef void (*rxCallBack)(char);
void rxInit(int8_t pin, rxCallBack Callback);
void interruptHandler();
rxCallBack rxCB;
uint32_t rxCode, rxSCode, rxTS[3];
uint16_t rxMin1, rxMax1, rxMin3, rxMax3, rxPer, rxDur;
uint8_t rxBit, rxRep, rxMRep;
int8_t rxState;
bool rxInCB;

void rxInit(int8_t pin, uint8_t rep, rxCallBack callback) {
  pinMode(pin, INPUT_PULLUP);
  rxMRep = rep;
  rxCB = callback;
  attachInterrupt(pin, interruptHandler, CHANGE);
}

void interruptHandler() {
  rxTS[1] = rxTS[2];
  rxTS[2] = micros();
  rxDur = rxTS[1] - rxTS[0];
  rxTS[0] = rxTS[1];
  if (rxState == -1) {
    if (rxDur <= 3720) return;
    rxPer = rxDur / 31;
    rxCode = rxSCode = rxRep = 0;
    rxMin1 = rxPer * 4 / 10;
    rxMax1 = rxPer * 16 / 10;
    rxMin3 = rxPer * 23 / 10;
    rxMax3 = rxPer * 37 / 10;
  }
  else if (rxState < 48) {
    rxBit <<= 1;
    if (rxDur <= rxMax1) rxBit &= B1110;
    else if (rxDur >= rxMin3 && rxDur <= rxMax3) rxBit |= B1;
    else {rxState = -1; return;}
   if ((rxState % 4) == 3) {
     rxCode *= 3;
      switch (rxBit & B1111) {
        case B0101: rxCode += 0; break;
        case B1010: rxCode += 1; break;
        case B0110: rxCode += 2; break;
        default: rxState = -1; return;
      }
    }
  } 
  else if (rxState == 48) { 
    if (rxDur > rxMax1) {rxState = -1; return;}
  }
  else {
    if (rxDur < rxPer * 25 || rxDur > rxPer * 36) {rxState = -1; return;}
    if (rxCode != rxSCode) {
      rxRep = 0;
      rxSCode = rxCode;
    }
    rxRep++;
    if (rxRep >= rxMRep) {
      if (!rxInCB) {
        rxInCB = true;
        (rxCB)(rxCode);
        rxInCB = false;
      }
      rxState = -1;
      return;
    }
    rxCode = 0;
    rxState = 0;
    return;
  }
  rxState++;
  return;
}

#endif
